var video = document.getElementsByTagName('video');
for(var i = 0 ; i < video.length; i++){
    video[i].addEventListener('play', onPlay);
    video[i].addEventListener('pause', onPause);
    video[i].addEventListener('reset', onReset);
    video[i].addEventListener('ended', onEnded);
    video[i].play();
}
function onPlay() {
    java2js_obj.notifyVideoPlay();
}
function onPause() {
    java2js_obj.notifyVideoPause();
}
function onReset() {
    java2js_obj.notifyVideoReset();
}
function onEnded() {
    java2js_obj.notifyVideoEnded();
}
function enterFullscreen() {
    for(var i = 0 ; i < video.length; i++){
        launchFullscreen(video[i]);
    }
}
function launchFullscreen(element)
{
    if (element.requestFullscreen) {
        element.requestFullscreen();
        java2js_obj.supportFullScreen("requestFullscreen");
    } else if(element.mozRequestFullScreen) {
        element.mozRequestFullScreen();
        java2js_obj.supportFullScreen("mozRequestFullScreen");
    } else if(element.msRequestFullscreen) {
        element.msRequestFullscreen();
        java2js_obj.supportFullScreen("msRequestFullscreen");
    } else if(element.oRequestFullscreen) {
        element.oRequestFullscreen();
        java2js_obj.supportFullScreen("oRequestFullscreen");
    } else if(element.webkitRequestFullscreen) {
        element.webkitRequestFullScreen();
        java2js_obj.supportFullScreen("webkitRequestFullScreen");
    } else {
        java2js_obj.notSupportFullScreen();
    }
}
